"""
###################################################################
# BA_Conbagui_Welded_Text.py Tutorial Scripted #
###################################################################
This script follows Conbagui's Welded Text Tutorial
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === ===
BA_Conbagui_Welded_Text instructions.txt
=== === === === === === === === === === === === === === === ===
This script needs both python LayerEffects
you can tell that you have the script by opening an image and right-clicking
on a layer in the layers box.  The the drop down menu appears an looking
at or very near the bottom you will see Layer Effects.   That is the python
version.  To find the .scm version - on the top menu click Script-Fu and
look for Layer Effects in the L's.   If you have them both you are ready.
=== === === === === === === === === === === === === === === ===
If not, download LayerFX.2.8.py and/or LayerFX.scm.
LayerFX.2.8.py needs to go into your Gimp plug-ins folder.
LayerFX.scm needs to go into your Gimp scripts folder.
When they have been placed, restart Gimp and look again to verify!
The 2 different scripts do not interfere with each other.
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === === 
In the zip file you should have 
Conbagui's Welded Text Tutorial.pdf which this script was based on.
If you enjoy learning new things in Gimp, I recommend you follow 
his tutorials, there is always something new to learn!  Thank you for 
another excellent tutorial Conbagui!
=== === === === === === === === === === === === === === === ===
Also, from his tutorial you should have received these pattern files :
Lava.jpg
metal grid-1.png
metal grit-1.pat
Metal with holes.pat
Move these 4 pattern files into your Gimp patterns folder.
=== === === === === === === === === === === === === === === ===
And he also includes some Spark brushes which should be moved 
into your Gimp brushes folder.
Color spark 1.gbr
Color spark 2.gbr
Color spark 3.gbr
Color spark 4.gbr
=== === === === === === === === === === === === === === === ===
And lastly,  This instruction sheet
BA_Conbagui_Welded_Text instructions.txt
And the python script
BA_Conbagui_Welded_Text.py
which should be moved into your Gimp plug-ins directory.
=== === === === === === === === === === === === === === === ===
If not, download LayerFX.2.8.py and/or LayerFX.scm.
LayerFX.2.8.py needs to go into your Gimp plug-ins folder.
LayerFX.scm needs to go into your Gimp scripts folder.
When they have been placed, restart Gimp and look again to verify!
The 2 different scripts do not interfere with each other.
=== === === === === === === === === === === === === === === ===
Open a new file with the exact width of 1600 and the exact height of 900
Put some text on a layer, then when done, make sure the layer is at the 
top of the layer stack and that it is active (when active it will have a white
box border around the picture of the layer in the layers area.
=== === === === === === === === === === === === === === === ===
After you have created your subject text then run the script.
=== === === === === === === === === === === === === === === ===
The outcome with this script is just 2 layers, the top has your processed
text layer, and the bottom is the generated background.   You can 
also replace the background at this time with an image of your choice.
=== === === === === === === === === === === === === === === ===
You can use the  'Curves' tool from the Colors menu at the top on either
or both of these layers.   I find that on the text layer, a leaning to the right 
S shape works nice to bring the colors out. You may have different tastes 
and there are other tools in the colors menu for you to bring out something 
you enjoy.   Brightness/Contrast is another tool I like on this one.
Desaturate follow with Colorize is another way, or just Colorize without
the desaturation. 
=== === === === === === === === === === === === === === === ===
The outcome with this script is just 2 layers, the top has your processed
text layer, and the bottom is the generated background.   You can 
also replace the background at this time with an image of your choice.
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === ===
===========================================================================================================
...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# You should have received a copy of the GNU General Public License       #
# along with this program if not, you can view the GNU General Public     #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                          #
###############################################################################
"""
#!/usr/bin/env python
from gimpfu import *

def BA_Conbagui_Welded_Text(inImage,inDrawable): 

#check for correct size
    if inImage.width != 1600 or inImage.height != 900 :
        pdb.gimp_message('Background Image must be 1920 Width x 1080 Height')
        return()    
####### create new image
    image = pdb.gimp_image_new(1600,900,RGB)
    pdb.gimp_context_push(image)
    frozen= pdb.gimp_image_undo_freeze(image)
####### Step 1  create background
    background=gimp.Image.new_layer(image)
    pdb.gimp_layer_add_alpha(background)
    background.name=('Background')
    pdb.gimp_context_set_pattern('Metal Grit-1')
    pdb.gimp_drawable_fill(background,4)
####### Step2 duplicate, add mode and merge into background layer
    duplayer = pdb.gimp_layer_copy(background,1)
    pdb.gimp_image_add_layer(image,duplayer,0)
    duplayer.name=('background copy')
    duplayer.mode=MULTIPLY_MODE
    duplayer1 = pdb.gimp_layer_copy(background,1)
    pdb.gimp_image_add_layer(image,duplayer1,1)
    duplayer1.name=('background1 copy')
    background = pdb.gimp_image_flatten(image)
####### Get the text layer from inImage
    textlay = pdb.gimp_layer_new_from_drawable(inDrawable,image) 
    image.add_layer(textlay)
    pdb.gimp_layer_add_alpha(textlay)
    textlay.name = 'textlay'
    pdb.gimp_context_set_foreground('#2c2323')
    pdb.gimp_image_select_item(image,0,textlay)
    pdb.gimp_edit_fill(textlay,0)
    textlaycopy = pdb.gimp_layer_copy(textlay,1)
    pdb.gimp_image_add_layer(image,textlaycopy,0)
    textlaycopy.name=('textlaycopy')
    pdb.gimp_selection_grow(image,2)
    pdb.gimp_edit_fill(textlaycopy,0)
    pdb.gimp_selection_none(image)
    pdb.gimp_item_set_visible(textlaycopy,False) 
    black='#000000'  

    pdb.script_fu_layerfx_drop_shadow(image,textlay,black,75.0,0,0,2,0,7,120,9,1,0)
    textdropshadow=pdb.gimp_image_get_active_layer(image)
    pdb.gimp_item_set_visible(textdropshadow,True)
    
    pdb.script_fu_layerfx_inner_glow(image,textlay,'#183755',75.0,0,0,5,0,0,6,1)
    textlay = pdb.gimp_image_get_active_layer(image)

    style=1
    depth=65 
    direction=0 
    size=7 
    soften=1
    angle=50
    altitude=58
    gloss_contour=0
    highlight_color='#99d2fb'
    highlight_mode=OVERLAY_MODE
    highlight_opacity=80.0
    shadow_color='#000000'
    shadow_mode=MULTIPLY_MODE
    shadow_opacity=25.0
    surface_contour=0
    use_texture=1
    pattern='Metal Grit-1'
    scale=50.0
    tex_depth=100.0
    invert=0
    merge=1
    pdb.python_layer_fx_bevel_emboss(image,textlay,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)
    textlay = pdb.gimp_image_get_active_layer(image)

    highlight_opacity=45.0
    highlight_color='#ffffff'
    shadow_opacity=35.0
    angle=55
    altitude=30

    pdb.python_layer_fx_bevel_emboss(image,textlay,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)
    textlay = pdb.gimp_image_get_active_layer(image)

    pattern='Lava.jpg'
    opacity=100.0
    mode=DIFFERENCE_MODE
    scale=20.0 
    interpolation=0
    merge=True
    pdb.python_layer_fx_pattern_overlay(image,textlay,pattern,opacity,mode,scale,interpolation,merge)
    textlay = pdb.gimp_image_get_active_layer(image)

    pdb.plug_in_waves(image,textlaycopy,2.0,76.0,50.0,0,0)

    textlaytemp = pdb.gimp_layer_copy(textlaycopy,1)
    pdb.gimp_image_add_layer(image,textlaytemp,1)
    textlaytemp.name=('TextLayTemp')
    pdb.gimp_item_set_visible(textlaytemp,True)   

    color='#000000'
    opacity=55.0
    contour=0
    noise=0.0
    mode=2 # gives Muliply Mode
    source=1
    choke=0
    size=6
    offset_angle=-77.0
    offset_distance=5.0
    merge=1 

    pdb.script_fu_layerfx_inner_shadow(image,textlaycopy,color,opacity,contour,noise,mode,source,choke,size,offset_angle,offset_distance,merge)
    textlaycopy1 = pdb.gimp_image_get_active_layer(image)

    foreground='#33303a'
    pdb.gimp_image_select_item(image,0,textlaycopy1)
    pdb.gimp_selection_shrink(image,3)
    pdb.gimp_context_set_foreground(foreground)    
    pdb.gimp_edit_fill(textlaycopy1,0)        
    pdb.gimp_selection_none(image)

    style=1
    depth=65 
    direction=0 
    size=10 
    soften=1
    angle=55.0
    altitude=58.0
    gloss_contour=0
    highlight_color='#ffffff'  #should be black99d2fb
    highlight_mode=OVERLAY_MODE
    highlight_opacity=75.0
    shadow_color='#99d2fb'
    shadow_mode=OVERLAY_MODE
    shadow_opacity=80.0
    surface_contour=0
    use_texture=1
    pattern='Metal Grit-1'
    scale=100.0
    tex_depth=10.0
    invert=0
    merge=0

    textlaycopy1.mode=SCREEN_MODE
    pdb.python_layer_fx_bevel_emboss(image,textlaycopy1,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)
    wrkimg=gimp.image_list()[0]
    wrklay=wrkimg.layers[1]
    wrklay.mode=SCREEN_MODE

    textlaycopytemp1=pdb.gimp_layer_copy(textlaycopy1,1)
    pdb.gimp_image_add_layer(image,textlaycopytemp1,2) 
    textlaycopytemp1.name=('TextLayTemp for outerglow')

    color='#d88511'
    opacity=100.0
    contour=0
    noise=0
    mode=6 #6 gives dodge-mode
    spread=10.0
    size=15
    knockout=1
    merge=0
    pdb.script_fu_layerfx_outer_glow(image,textlaycopytemp1,color,opacity,contour,noise,mode,spread,size,knockout,merge)
    textouterglow = pdb.gimp_image_get_active_layer(image)
    textouterglow.name='text1-outerglow'
    pdb.gimp_image_remove_layer(image,textlaycopytemp1)
    pdb.gimp_image_remove_layer(image,textlaycopy)

    pattern='Lava.jpg'
    opacity=100.0
    mode=NORMAL_MODE
    scale=35.0 
    interpolation=0
    merge=False
    pdb.python_layer_fx_pattern_overlay(image,textouterglow,pattern,opacity,mode,scale,interpolation,merge)
    textouterglow1 = pdb.gimp_image_get_active_layer(image)
    imglist=gimp.image_list()[0]
    wrklay=imglist.layers[1]
    wrklay.mode=DODGE_MODE #16
    pdb.gimp_layer_set_visible(background,False)
    layer = pdb.gimp_image_merge_visible_layers(image,0)
    pdb.gimp_layer_set_visible(background,True)
  
    pdb.gimp_context_pop(image)
    pdb.gimp_displays_flush
    pdb.gimp_display_new(image)
    pdb.gimp_image_undo_thaw(image)
    return()
register(
    "BA_Conbagui_Welded_Text",    
    "Script Based On Conbagui's Welded_Text",   
    "Requirments show at top",
    "animicule@gimpchat.com", 
    "Brian Andersen", 
    "July 2017",
    "BA Conbagui Welded Text", 
    "RGB*", 
   [
      (PF_IMAGE,   "inImage",    "Input image         ",  None),
      (PF_DRAWABLE,"inDrawable", "Input drawable      ",  None),
    ], 
    [],
    BA_Conbagui_Welded_Text,
    menu="<Image>/Brian/",
    )

main()
